/**
 * ECPoint.cpp - Bitcoin poscript generator
 *
 * Copyright (C)2015 The bitgen developers <bitgen@openmailbox.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include "xmrECPoint.h"
#include "xmrEC.h"


std::string XmrECPoint::toString() const
{
	std::string ret;
	ret += "(";
	ret += x.strHex();	
	ret += ", ";
	ret += y.strHex();		
	ret += ")";
	
	return ret;
}





bool operator==(const XmrECPoint& a, const XmrECPoint& b)
{
	return (a.getX() == b.getX()) && (a.getY() == b.getY());
}

bool operator!=(const XmrECPoint& a, const XmrECPoint& b)
{
	return !(a == b);
}



std::ostream& operator<<(std::ostream& s, const XmrECPoint& point)
{
	s << "(" << point.getX() << "\n" << point.getY() << ")";
	return s;
}




